package tests;

import models.Singleton3;

/**
 * Test class for {@link Singleton3}<br>
 * 
 * <ul>
 * <li>Construct two {@link Singleton3} instances/objects using the
 * {@link Singleton3#instance()} method</li>
 * <li>Set the {@link Singleton3#data} value of the first instance and print information
 * concerning both objects to the screen</li>
 * <li>Check - on the screen output - that the references and values for both
 * objects are the same</li>
 * </ul>
 * <br>
 * EXPECTED (TYPICAL) OUTPUT
 * 
 * <pre>
 * First singleton3: models.Singleton1@70dea4e
 * First singleton3 data value =  34
 * Second singleton3: models.Singleton1@70dea4e
 * Second singleton3 data value =  34
 * 
 *  CHECK - on the previous output - that the references and values for both objects are the same
 * </pre>
 * 
 * @author J Paul Gibson
 */
public class TestSingleton3 {

	public static void main(String args[]) {

		final int TEST_DATA_VALUE = 34; // An arbitrary value for testing
										// purposes

		// Construct 2 singleton3 objects using the instance method
		Singleton3 s1a = Singleton3.instance();
		Singleton3 s1b = Singleton3.instance();

		// Set the data value.
		s1a.setData(TEST_DATA_VALUE);
		System.out.println("First singleton3: " + s1a);
		System.out.println("First singleton3 data value =  " + s1a.getData());
		System.out.println("Second singleton3: " + s1b);
		System.out.println("Second singleton3 data value =  " + s1b.getData());

		// Check - on the screen output - that the references and values for
		// both objects are the same
		System.out
				.println("\n CHECK - on the previous output - that the references and values for both objects are the same");
	}
}
