package tests;

import models.Singleton4;

/**
 * Test class for {@link Singleton4}<br>
 * 
 * <ul>
 * <li>Construct two {@link Singleton4} instances/objects using the
 * {@link Singleton4#getInstance()} method</li>
 * <li>Set the {@link Singleton4#data} value of the first instance and print information
 * concerning both objects to the screen</li>
 * <li>Check - on the screen output - that the references and values for both
 * objects are the same</li>
 * </ul>
 * <br>
 * EXPECTED (TYPICAL) OUTPUT
 * 
 * <pre>
 * First singleton4: models.Singleton1@70dea4e
 * First singleton4 data value =  34
 * Second singleton4: models.Singleton1@70dea4e
 * Second singleton4 data value =  34
 * 
 *  CHECK - on the previous output - that the references and values for both objects are the same
 * </pre>
 * 
 * @author J Paul Gibson
 */
public class TestSingleton4 {

	public static void main(String args[]) {

		final int TEST_DATA_VALUE = 34; // An arbitrary value for testing
										// purposes

		// Construct 2 singleton objects using the instance method
		Singleton4 s4a = Singleton4.getInstance();
		Singleton4 s4b = Singleton4.getInstance();

		// Set the data value.
		s4a.setData(TEST_DATA_VALUE);
		System.out.println("First singleton4: " + s4a);
		System.out.println("First singleton4 data value =  " + s4a.getData());
		System.out.println("Second singleton4: " + s4b);
		System.out.println("Second singleton4 data value =  " + s4b.getData());

		// Check - on the screen output - that the references and values for
		// both objects are the same
		System.out.println("\n CHECK - on the previous output - that the references and values for both objects are the same");
	}
}
